<template>
  <div class="dynamic-chart-panel d-flex flex-grow-1 flex-column">
    <!-- loading spinner -->
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-4">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"/>
          </span>
        </div>
      </div>
    </template>

    <!-- error on download -->
    <template v-else-if="error">
      <div class="d-flex flex-grow-1">
        <div class="text-center mx-auto my-4">
          <h1><font-awesome-icon icon="dizzy"></font-awesome-icon></h1>
          <div class="error-message">{{ error }}</div>
        </div>
      </div>
    </template>

    <template v-else>
      <!-- chart area -->
      <div class="chart-area d-flex flex-grow-1 flex-row py-4">

        <!-- options -->
        <div class="d-flex flex-grow-0 flex-column px-4">
          <div class="form-group mb-4">
            <label for="chart-variable-filter">Filtrar</label><br>
            <input class="form-control" id="chart-variable-filter" placeholder="Filtrar">
          </div>
          <!--<div class="d-flex flex-grow-1">-->
          <div class="form-group d-flex flex-grow-1 flex-column">
            <label for="chart-variable-select">Lista de variáveis</label><br>
            <select id="chart-variable-select" class="form-control flex-grow-1" v-model="dataSelect" multiple>
              <option value="arome.temperature.continent.surface">Temperatura à superficie</option>
              <option value="arome.temperature.continent.950">Temperatura a 950 hPa</option>
              <option value="arome.temperature.continent.925">Temperatura a 925 hPa</option>
              <option value="arome.temperature.continent.900">Temperatura a 900 hPa</option>
              <option value="arome.temperature.continent.850">Temperatura a 850 hPa</option>
              <option value="arome.temperature.continent.800">Temperatura a 800 hPa</option>
              <option value="arome.temperature.continent.700">Temperatura a 700 hPa</option>
              <option value="arome.temperature.continent.500">Temperatura a 500 hPa</option>
              <option value="arome.temperature.continent.300">Temperatura a 300 hPa</option>
              <option value="arome.pressure.continent">Pressão à superficie</option>
              <option value="arome.relative_humidity.continent.surface">Humidade relativa à superficie</option>
              <option value="arome.relative_humidity.continent.950">Humidade relativa a 950 hPa</option>
              <option value="arome.relative_humidity.continent.925">Humidade relativa a 925 hPa</option>
              <option value="arome.relative_humidity.continent.900">Humidade relativa a 900 hPa</option>
              <option value="arome.relative_humidity.continent.800">Humidade relativa a 800 hPa</option>
              <option value="arome.relative_humidity.continent.700">Humidade relativa a 700 hPa</option>
              <option value="arome.relative_humidity.continent.500">Humidade relativa a 500 hPa</option>
              <option value="arome.relative_humidity.continent.300">Humidade relativa a 300 hPa</option>
              <option value="arome.dewpoint.continent">Ponto de orvalho</option>
              <option value="arome.high_cloud_cover.continent">Nuvens altas</option>
              <option value="arome.medium_cloud_cover.continent">Nuvens médias</option>
              <option value="arome.low_cloud_cover.continent">Nuvens baixas</option>
              <option value="arome.total_cloud_cover.continent">Nuvens totais</option>
              <option value="arome.precipitation.continent">Precipitação</option>
              <option value="arome.vertical_velocity.continent.950">Velocidade vertical a 950 hPa</option>
              <option value="arome.vertical_velocity.continent.925">Velocidade vertical a 925 hPa</option>
              <option value="arome.vertical_velocity.continent.900">Velocidade vertical a 900 hPa</option>
              <option value="arome.vertical_velocity.continent.850">Velocidade vertical a 850 hPa</option>
              <option value="arome.vertical_velocity.continent.800">Velocidade vertical a 800 hPa</option>
              <option value="arome.vertical_velocity.continent.700">Velocidade vertical a 700 hPa</option>
              <option value="arome.vertical_velocity.continent.500">Velocidade vertical a 500 hPa</option>
              <option value="arome.vertical_velocity.continent.300">Velocidade vertical a 300 hPa</option>
              <option value="arome.geopotential.continent.950">Geopotencial a 950 hPa</option>
              <option value="arome.geopotential.continent.925">Geopotencial a 925 hPa</option>
              <option value="arome.geopotential.continent.900">Geopotencial a 900 hPa</option>
              <option value="arome.geopotential.continent.850">Geopotencial a 850 hPa</option>
              <option value="arome.geopotential.continent.800">Geopotencial a 800 hPa</option>
              <option value="arome.geopotential.continent.700">Geopotencial a 700 hPa</option>
              <option value="arome.geopotential.continent.500">Geopotencial a 500 hPa</option>
              <option value="arome.geopotential.continent.300">Geopotencial a 300 hPa</option>
            </select>
          </div>
        </div>

        <!-- main area -->
        <div class="d-flex flex-grow-1 px-4">
          <div class="main-chart-area">
            <base-chart ref="chart" :styles="chartStyle()" :options="chartOptions" :chart-data="dataCollection"/>
          </div>
        </div>
      </div>
    </template>
  </div>
</template>

<script>
import moment from 'moment'
import ClipLoader from 'vue-spinner/src/ClipLoader'
import BaseChart from '@/core/charts/mixins/BaseChart'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import { datasetOptions, axisOptions } from './data.js'
import { buildQueryUrl, getFeatureInfo } from '@/query/retrieve'

export default {
  name: 'dynamicchartpanel',

  mixins: [
    WorkspaceGetter,
  ],

  props: {
    locationId: {
      type: String,
      required: true
    }
  },

  data() {
    return {
      loading: true,
      error: null,
      dataSelect: [
        'arome.temperature.continent.surface',
      ],
    }
  },

  computed: {
    location: {
      get() {
        return this.$store.getters.workspaceLocationById(this.workspaceId, this.locationId)
      }
    },

    referenceTime: {
      get() {
        return this.$store.getters.workspaceReferenceTime(this.workspaceId)
      },
    },

    query: {
      get() {
        return this.$store.getters.workspaceQuery(this.workspaceId)
      }
    },

    queryRequestCache: {
      get() {
        return this.$store.getters.workspaceQueryRequestCache(this.workspaceId)
      }
    },

    dataCollection: {
      get() {
        return {
          datasets: this.dataSelect.map((item) => {
            return {
              ...datasetOptions[item],
              data: this.getCollectionForItem(item),
            }
          })
        }
      }
    },

    chartOptions: {
      get() {
        return {
          responsive: true,
          maintainAspectRatio: false,
          tooltips: {
            mode: 'index',
            intersect: false,
            callbacks: {
              title: (item) => {
                return moment(item[0].label).format('YYYY-MM-DD HH:mm')
              }
            },
          },
          hover: {
            mode: 'nearest',
            intersect: true,
          },
          scales: {
            xAxes: [{
              type: 'time',
              time: { unit: 'hour', displayFormats: { hour: 'H[h]' } },
              scaleLabel: {
                display: true,
                labelString: 'Data e hora'
              }
            }],
            yAxes: this.dataSelect.map((item, index) => {
              let position = index % 2 === 0 ? 'left': 'right'
              return {
                ...axisOptions[datasetOptions[item].yAxisID],
                position: position,
              }
            })
          },
        }
      }
    },
  },

  methods: {
    getCollectionForItem(item) {
      let name = this.getLayerNameFromName(item)

      return [...Array(48).keys()].map((i) => {
        return moment.unix(this.referenceTime).add(i, 'hours').format('YYYY-MM-DDTHH:00:00')
      }).map((time) => {
        try {
          return {
            t: time,
            y: this.query.data[name][time]['surface']
          }
        } catch {
          return {
            t: time,
            y: null,
          }
        }
      })
    },

    chartStyle() {
      return {
        height: '300px',
        position: 'relative',
      }
    },

    generateTimeList() {
      return [...Array(48).keys()].map((i) => {
        return moment.unix(this.referenceTime).add(i, 'hours').format('YYYY-MM-DDTHH:00:00')
      })
    },

    parseFeatureInfoResponse(response) {
      this.$store.dispatch('setWorkspaceQueryRequestCache', {
        workspaceId: this.workspaceId,
        requestHash: response.config.url,
        response: response
      })
    },

    getLayerNameFromName(name) {
      const mappings = {
        'arome.temperature.continent.surface': 'arome.temperature.continent',
        'arome.temperature.continent.950': 'arome.temperature.continent',
        'arome.temperature.continent.925': 'arome.temperature.continent',
        'arome.temperature.continent.900': 'arome.temperature.continent',
        'arome.temperature.continent.850': 'arome.temperature.continent',
        'arome.temperature.continent.800': 'arome.temperature.continent',
        'arome.temperature.continent.700': 'arome.temperature.continent',
        'arome.temperature.continent.500': 'arome.temperature.continent',
        'arome.temperature.continent.300': 'arome.temperature.continent',
      }

      return mappings[name]
    },

    getData() {
      let requests = this.dataSelect.map((name) => {
        return buildQueryUrl({
          latitude: this.location.latitude,
          longitude: this.location.longitude,
          layer: this.getLayerNameFromName(name),
          reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00[Z]'),
          time: this.generateTimeList(),
        })
      }).filter((url) => {
        return !(url in this.queryRequestCache)
      }).map((url) => {
        getFeatureInfo(url)
      })

      Promise.all(requests).then((responses) => {
        responses.forEach((response) => {
          this.parseFeatureInfoResponse(response)
        })
        this.loading = false
      }).catch(() => {
        this.error = 'Ocorreu um erro ao descarregar os dados'
        this.loading = false
      })
    },
  },

  watch: {
    dataSelect() {
      this.getData()
    }
  },

  mounted() {
    this.getData()
  },

  components: {
    ClipLoader,
    BaseChart,
  },
}
</script>

<style scoped>
.main-chart-area {
  display: block;
  position: relative;
  height: 300px;
  max-height: 300px;
  width: 98%;
  float: left;
}
</style>
